using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;

namespace HiToText
{
    abstract class Hiscore
    {
        protected string m_fileName = null;
        protected byte[] m_data = null;

        protected int m_numEntries = 0;
        protected string m_format = "";
        protected string m_gamesSupported = "";

        protected bool m_needsReadOnlyNVRAM = false;

        public Hiscore(string fileName)
        {
            if (!String.IsNullOrEmpty(fileName))
            {
                if(File.Exists(fileName))
                {
                    m_fileName = fileName;
                    m_data = File.ReadAllBytes(fileName);
                }
            }
        }

        public abstract string HiToString();

        public abstract void SetHiScore(String[] args);

        public int NumEntries
        {
            get { return m_numEntries; }
        }

        public string Format
        {
            get { return m_format; }
        }

        public int FieldCount
        {
            get { return m_format.Split(new char[] { '|' }).Length; }
        }

        public string GamesSupported
        {
            get { return m_gamesSupported; }
        }

        public bool NeedsReadOnlyNVRAM
        {
            get { return m_needsReadOnlyNVRAM; }
        }

        public void SaveData()
        {
            File.WriteAllBytes(m_fileName, m_data);
        }
    }
}
